2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6155 Subsequence Count 矩阵快速幂

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6155

题意:

题解来自:http://www.cnblogs.com/iRedBean/p/7398272.html

先考虑dp求01串的不同子序列的个数。

dp[i][j]表示用前i个字符组成的以j为结尾的01串个数。

如果第i个字符为0,则dp[i][0] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][1] = dp[i-1][1]

如果第i个字符为1,则dp[i][1] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][0] = dp[i-1][0]

显然这是线性递推,我们考虑如何用矩阵表示这种递推关系。

下面分别对应加入一个字符0或1时表示递推关系的矩阵。

然后用线段树维护每个区间的矩阵乘积就可以解决查询操作了。

对于修改操作,我们给区间维护一个flip标记,表示该区间是否要翻转,用线段树区间更新的方法去更新flip标记就好了。

将一个区间翻转后,它对应矩阵也要发生改变,这里我们只要将矩阵的第一列与第二列交换后再将第一行与第二行交换就好了。

#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5+6;
const int mod = 1e9+7;
typedef long long LL;
struct Matrix{
    LL maze[3][3];
    friend Matrix operator*(const Matrix& a, const Matrix& b){
        Matrix c;
        for(int i=0; i<3; i++){
            for(int j=0; j<3; j++){
                c.maze[i][j]=0;
                for(int k=0; k<3; k++){
                    c.maze[i][j]+=a.maze[i][k]*b.maze[k][j];
                    c.maze[i][j]%=mod;
                }
            }
        }
        return c;
    }
};
const Matrix m[2]={{1,0,0,1,1,0,1,0,1},{1,1,0,0,1,0,0,1,1}};
Matrix T[maxn<<2];
bool flip[maxn<<2];
char s[maxn];
void build(int l, int r, int rt){
    flip[rt] = 0;
    if(l == r){
        T[rt] = m[s[l]-‘0‘];
        return;
    }
    int mid = (l+r)>>1;
    build(l, mid, rt*2);
    build(mid+1, r, rt*2+1);
    T[rt] = T[rt*2]*T[rt*2+1];
}
void Flip(Matrix &mat){
    swap(mat.maze[0][0],mat.maze[0][1]);
    swap(mat.maze[1][0],mat.maze[1][1]);
    swap(mat.maze[2][0],mat.maze[2][1]);
    swap(mat.maze[0][0],mat.maze[1][0]);
    swap(mat.maze[0][1],mat.maze[1][1]);
    swap(mat.maze[0][2],mat.maze[1][2]);
}
void pushdown(int rt){
    if(flip[rt]){
        flip[rt*2]^=flip[rt];
        flip[rt*2+1]^=flip[rt];
        Flip(T[rt*2]);
        Flip(T[rt*2+1]);
        flip[rt]=false;
    }
}
void update(int L, int R, int l, int r, int rt){
    if(L<=l&&r<=R){
        flip[rt]^=1;
        Flip(T[rt]);
        return;
    }
    pushdown(rt);
    int mid=(l+r)/2;
    if(R<=mid) update(L,R,l,mid,rt*2);
    else if(L>mid) update(L,R,mid+1,r,rt*2+1);
    else{
        update(L,mid,l,mid,rt*2);
        update(mid+1,R,mid+1,r,rt*2+1);
    }
    T[rt]=T[rt*2]*T[rt*2+1];
}
Matrix query(int L, int R, int l, int r, int rt){
    if(L<=l&&r<=R){
        return T[rt];
    }
    pushdown(rt);
    int mid=(l+r)/2;
    if(R<=mid) return query(L,R,l,mid,rt*2);
    else if(L>mid) return query(L,R,mid+1,r,rt*2+1);
    else return query(L,mid,l,mid,rt*2)*query(mid+1,R,mid+1,r,rt*2+1);
}
int main()
{
    int T,n,q;
    scanf("%d", &T);
    while(T--)
    {
        scanf("%d%d",&n,&q);
        scanf("%s",s+1);
        build(1,n,1);
        while(q--)
        {
            int op,l,r;
            scanf("%d%d%d",&op,&l,&r);
            if(op==1) update(l,r,1,n,1);
            else{
                Matrix ret = query(l,r,1,n,1);
                printf("%lld\n", (ret.maze[2][0]+ret.maze[2][1])%mod);
            }
        }
    }
    return 0;
}
时间: 2024-10-02 07:38:13

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6155 Subsequence Count 矩阵快速幂的相关文章

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6154 CaoHaha&#39;s staff 思维

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6154 题意:在笛卡尔坐标系下,画一个面积至少为  n 的简单多边形,每次只能画一条边或者一个格子的对角线,问至少要画几条. 解法:如果一个斜着的矩形长宽分别是 a,b,那么它的面积是 2ab.最优解肯定是离 sqrt(n/2)很近的位置.想想 n=5 时答案为什么是7 然后在那个小范围内枚举一下就好了.我给一张做题时画的图 #include <bits/stdc++.h> using namesp

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6154 CaoHaha&#39;s staff(几何找规律)

Problem Description "You shall not pass!"After shouted out that,the Force Staff appered in CaoHaha's hand.As we all know,the Force Staff is a staff with infinity power.If you can use it skillful,it may help you to do whatever you want.But now,hi

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6153 A Secret KMP,思维

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6153 题意:给了串s和t,要求每个t的后缀在在s中的出现次数,然后每个次数乘上对应长度求和. 解法:关键在于想到把s和t都翻转之后,把t求next,然后用t去匹配s,在匹配过程中把fail指针跳到的地方加1,但是还没完,最后需要反向遍历第二个串将大串对小串的贡献加上去就可以了. 这道题是很多现场AC的代码是有漏洞的,比如bazbaba,bazbaba这个答案是34,但是很多现场AC的代码会输出31.

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6150 Vertex Cover 二分图,构造

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6150 题意:"最小点覆盖集"是个NP完全问题 有一个近似算法是说-每次选取度数最大的点(如果有多个这样的点,则选择最后一个) 让你构造一个图,使得其近似算法求出来点数是你给定的覆盖点数的至少3倍. 解法: 可以把左边的点编号1~n,将左边的点进行n次分块,第i次分块中每块的大小为i,对于每一块的点,都在右边创建一个新节点与这些点相连. ①右边的点的度数为n,n-1,n-2,...,n/2,

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6156 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6156 题意:如题. 解法:数位DP,暴力枚举进制之后,就转化成了求L,R区间的回文数的个数,这个直接做一个数位DP就好了.dp[jz][start][cur][state]表示jz进制下以start位起始到cur位状态为state(1表示已经回文,0表示没有回文)时回文数的个数. #include <bits/stdc++.h> using namespace std; typedef long

2017中国大学生程序设计竞赛 - 网络选拔赛 1004

A Secret Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 256000/256000 K (Java/Others)Total Submission(s): 0    Accepted Submission(s): 0 Problem Description Today is the birthday of SF,so VS gives two strings S1,S2 to SF as a present,which h

2017中国大学生程序设计竞赛 - 网络选拔赛 1005

CaoHaha's staff Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 0    Accepted Submission(s): 0 Problem Description "You shall not pass!"After shouted out that,the Force Staff appered in Cao

2017中国大学生程序设计竞赛 - 网络选拔赛

Friend-Graph Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6514    Accepted Submission(s): 1610 Problem Description It is well known that small groups are not conducive of the development of

HDU 5833 Zhu and 772002(高斯消元)——2016中国大学生程序设计竞赛 - 网络选拔赛

传送门 Zhu and 772002 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 48    Accepted Submission(s): 16 Problem Description Zhu and 772002 are both good at math. One day, Zhu wants to test the abili